<?

 /*************************************************************************************
 * Filename: setup.php
 *
 * This file is part of the Login JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Login JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/contact/
 *************************************************************************************/


 class Plugin_Setup_contact extends Base_Plugin_Setup
 {
  function init()
  {
   global $_path;

   $this->modules();

   return true;
  }

  function postSetup()
  {
   $CONTACTID="LOG CONTAINER";

   //get root category
   $d=Data::cache("categories", "tree", "down");
   $d->setShowFields("nr");

   $d->setValue("catnr", 0);
   $d->setValue("treedepth", 0);

   if(!$d->get()||!$d->next())
   {
    $this->e->add("Root category not found");
    $this->e->add($d->e);
    return false;
   }

   $rootcatnr=$d->v["nr"];

   //get contact category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $rootcatnr);
   $d->setValue("text", $CONTACTID);

   if(!$d->get()||!$d->next()) //no contact category found
   {
    //add new contact category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $rootcatnr);
    $d->setValue("name", "Contact");
    $d->setValue("text", $CONTACTID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("contact_feedback"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("Contact category added", "note");

    $contactcatnr=$d->getValue("nr");
   }
   else //contact category found
   {
    //update if necessary
    $contactcatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("contact_feedback", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $contactcatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("contact_feedback"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("Contact category updated", "note");
    }
   }

   return true;
  }

 }
?>
